diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
index 6893ad3bd..f2f6d2297 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeMangrove.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreeMangrove
     extends WorldFeatureSpoonerTreeRound {
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeMangrove(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
index f97b0d722..6143cc9f2 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeNormal.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreeNormal
     extends WorldFeatureSpoonerTreeStick {
 
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeNormal(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
index 66ce45ee3..9bd66e89d 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreePalm.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreePalm
     extends WorldFeatureSpoonerTree {
 
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreePalm(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
index f4aaaf686..4fb1cc92a 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeProcedural.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -21,6 +22,7 @@ public abstract class WorldFeatureSpoonerTreeProcedural
     protected double[] foliageShape = null;
     protected List<int[]> foliageCoords = null;
 
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeProcedural(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java
index 428f907a2..2415a7a87 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRainforest.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreeRainforest
     extends WorldFeatureSpoonerTreeProcedural {
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeRainforest(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java
index 66033596d..559993d4e 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeRound.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public class WorldFeatureSpoonerTreeRound
     extends WorldFeatureSpoonerTreeProcedural {
 
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeRound(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java
index 5334b562c..b16e395e1 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTreeStick.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
 
 public abstract class WorldFeatureSpoonerTreeStick
     extends WorldFeatureSpoonerTree {
+    @MethodParametersAnnotation(names = {"height", "trunkId", "trunkData", "leavesId", "leavesData"})
     public WorldFeatureSpoonerTreeStick(int height, int trunkId, int trunkData, int leavesId, int leavesData) {
         super(height, trunkId, trunkData, leavesId, leavesData);
     }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeNether.java b/src/main/java/net/minecraft/core/world/type/WorldTypeNether.java
index 1417e4aa6..1a6f9d382 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeNether.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeNether.java
@@ -1,7 +1,9 @@
 package net.minecraft.core.world.type;
 
+import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
@@ -63,7 +65,7 @@ public abstract class WorldTypeNether
     @Override
     public BiomeProvider createBiomeProvider(World world)
     {
-        return new BiomeProviderSingleBiome(Biomes.NETHER_NETHER, 1.0, 1.0, 1.0);
+        return new BiomeProviderSingleBiome(Biomes.NETHER_NETHER, 1.0, 0.0, 1.0);
     }
 
     @Override
@@ -103,6 +105,18 @@ public abstract class WorldTypeNether
     @Override
     public Vec3d getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick)
     {
+    	if(Colorizers.fog.isEnabled()) {
+	    	int x1 = MathHelper.floor_double(x);
+	    	int y1 = MathHelper.floor_double(y);
+	    	int z1 = MathHelper.floor_double(z);
+	    	
+	    	int color = Colorizers.fog.getColor(world, x1, y1, z1);
+	    	
+	    	float r = ((color >> 16) & 0xFF) / 255.0f;
+	    	float g = ((color >> 8) & 0xFF) / 255.0f;
+	    	float b = (color & 0xFF) / 255.0f;
+	    	return Vec3d.createVector(r, g, b);
+	    }
         return Vec3d.createVector(0.0, 0.0, 0.0);
     }
 
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldAmplified.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldAmplified.java
index b22c248b8..a2a529ac8 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldAmplified.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldAmplified.java
@@ -18,10 +18,10 @@ public class WorldTypeOverworldAmplified
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldExtended.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldExtended.java
index 97ab16930..7befdd494 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldExtended.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldExtended.java
@@ -18,10 +18,10 @@ public class WorldTypeOverworldExtended
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldFloating.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldFloating.java
index d6b9f890a..4f50e5acd 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldFloating.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldFloating.java
@@ -21,10 +21,10 @@ public class WorldTypeOverworldFloating
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldInland.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldInland.java
index 1af4de983..a1215b593 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldInland.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldInland.java
@@ -20,10 +20,10 @@ public class WorldTypeOverworldInland
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIslands.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIslands.java
index c1f5aaf2c..09725306a 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIslands.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldIslands.java
@@ -18,10 +18,10 @@ public class WorldTypeOverworldIslands
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldWoods.java b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldWoods.java
index 542a386ad..b525c04d5 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldWoods.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypeOverworldWoods.java
@@ -20,10 +20,10 @@ public class WorldTypeOverworldWoods
             Weather.overworldClear,
             new WindManagerGeneric(),
             SeasonConfig.builder()
-                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 7)
-                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 7)
+                .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
                 .build()
         );
     }
